// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int a = input<int>();

    vector<int> arr(a);
    input_seq(ALL(arr));

    if (*std::max_element(ALL(arr)) == 0) {
        cout << -1 << "\n";
        return 0;
    }
    
    int len;
    int64_t cur_pow = 1;
    for (len = 1; true; ++len) {
        cur_pow *= a;

        int64_t n0 = (len - 1) * (cur_pow - cur_pow / a) / a;
        int64_t nother = n0 + (cur_pow - cur_pow / a) / (a - 1);

        if (arr[0] < n0 or *std::min_element(arr.begin() + 1, arr.end()) < nother)
            break;

        arr[0] -= n0;
        for (int i = 1; i < a; ++i)
            arr[i] -= nother;
    }

    cur_pow /= a;
    
    int64_t rem = std::accumulate(ALL(arr), int64_t(0));
    if (rem % len) {
        cout << -1 << "\n";
        return 0;
    }

    if (rem == 0) {
        cout << cur_pow - 1 << "\n";
        return 0;
    }
    
    rem /= len;
    --rem;

    int64_t num = rem;

    //12345

    int64_t pw = 1;
    for (int pos = 0; pos < len; ++pos, pw *= a) {
        for (int i = 0; i < a - (pos == len - 1); ++i)
            if (i < num % a)
                arr[i + (pos == len - 1)] -= (1 + (num / a)) * pw;
            else if (i > num % a)
                arr[i + (pos == len - 1)] -= (num / a) * pw;
            else
                arr[i + (pos == len - 1)] -= (num / a) * pw + (rem % pw + 1);

        num /= a;
    }

    if (*std::min_element(ALL(arr)) != 0 or *std::max_element(ALL(arr)) != 0) {
        cout << -1 << "\n";
    } else {    
        cout << cur_pow + rem << "\n";
    }

    return 0;
}
