// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int a;
	cin >> a;
	vector<int> arr;
	for (int i = 0; i < a; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}
	
	if (*max_element(arr.begin(), arr.end()) == 0) {
	    cout << "-1\n";
	    return;
	}

	vector<int> arrn;
	auto calc_digits = [&](ll n, int dig) {
		arrn.clear();
		while (n) {
			arrn.push_back(n % a);
			n /= a;
		}
		reverse(arrn.begin(), arrn.end());
		ll ret = 0;
		ll cp = 1;
		for (int l = 1; l < szof(arrn); ++l) {
			ret += (l - 1) * (a - 1) * cp / a;
			if (dig != 0) {
				ret += cp;
			}
			cp *= a;
		}
		int was = 0;
		for (int i = 0; i < szof(arrn); ++i) {
			int from = 0;
			if (i == 0) {
				from = 1;
			}
			if (from <= dig && dig < arrn[i]) {
				ret += cp;
			}
			ret += was * (arrn[i] - from) * cp;
			ret += (arrn[i] - from) * (szof(arrn) - 1 - i) * cp / a;
			cp /= a;
			was += arrn[i] == dig;
		}
		ret += was;
		return ret;
	};

	ll l = 0, r = 1e17;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		bool ok = true;
		for (int i = 0; i < a; ++i) {
			if (calc_digits(mid, i) > arr[i]) {
				ok = false;
				break;
			}
		}
		if (ok) {
			l = mid;
		} else {
			r = mid;
		}
	}

	bool ok = true;
	for (int i = 0; i < a; ++i) {
		if (calc_digits(l, i) != arr[i]) {
			ok = false;
			break;
		}
	}

	if (ok) {
		cout << l << "\n";
	} else {
		cout << "-1\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
