#include <iostream>
#include <stdio.h>
#include <vector>
#include <array>
#include <map>
using namespace std;

vector<vector<long long> > dp;
vector<int> s;
int n;

const long long INF = 1000000007;

int main() {
    ios_base::sync_with_stdio(0);
    cin >> n;
    dp.resize(n);
    s.resize(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(26);
        cin >> s[i];
    }
    dp[0][s[0]] = 1;
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < 26; j++) {
            if (j + s[i + 1] < 26) {
                dp[i + 1][j + s[i + 1]] = (dp[i + 1][j + s[i + 1]] + dp[i][j]) % INF;
            }
            if (j - s[i + 1] >= 0 && s[i + 1] != 0) {
                dp[i + 1][j - s[i + 1]] = (dp[i + 1][j - s[i + 1]] + dp[i][j]) % INF;
            }
        }
    }
    long long ans = 0;
    for (int i = 0; i < 26; i++) {
        ans = (ans + dp[n - 1][i]) % INF;
    }
    cout << ans << endl;
    return 0;
}