#include <iostream>
#include <stdio.h>
#include <vector>
#include <array>
#include <map>
using namespace std;

vector<long long> dp1;
vector<long long> dp2;
vector<int> s;
int n;

const long long INF = 1000000007;

int main() {
    ios_base::sync_with_stdio(0);
    cin >> n;
    dp1.resize(26);
    dp2.resize(26);
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    dp1[s[0]] = 1;
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < 26; j++) {
            if (j + s[i + 1] < 26) {
                dp2[j + s[i + 1]] = (dp2[j + s[i + 1]] + dp1[j]) % INF;
            }
            if (j - s[i + 1] >= 0 && s[i + 1] != 0) {
                dp2[j - s[i + 1]] = (dp2[j - s[i + 1]] + dp1[j]) % INF;
            }
        }
        swap(dp1, dp2);
        fill(dp2.begin(), dp2.end(), 0);
    }
    long long ans = 0;
    for (int i = 0; i < 26; i++) {
        ans = (ans + dp1[i]) % INF;
    }
    cout << ans << endl;
    return 0;
}