#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int n, vector<pair<int, int>>& test) 
{
    cout << n << ' '  << test.size() << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first + 1 << ' ' << test[i].second + 1 << endl;
}

long long calc_edges(int n) 
{
    return 1ll * n * (n - 1) / 2;
}

void gen(int n)
{
    vector<pair<int, int>> e;
    
    map<pair<int, int>, bool> used;
    
    int c = rnd.next(1, n / 2);
    vector<int> cnt_v(c, 1);
    for (int i = c; i < n; i++)
    {
        int v = rnd.next(0, c - 1);
        cnt_v[v]++;
    }
    vector<int> v(n);
    iota(v.begin(), v.end(), 0);
    shuffle(v.begin(), v.end());
    int sum_v = 0;
    for (int i = 0; i < c; i++)
    {
        for (int j = 0; j < cnt_v[i] - 1; j++)
        {
            int cur = v[sum_v + j];
            int nxt = v[sum_v + j + 1];
            if (rnd.next(2))
                e.push_back(make_pair(cur, nxt));
            else 
                e.push_back(make_pair(nxt, cur));
        }    
        sum_v += cnt_v[i];
    }
    
    shuffle(e.begin(), e.end());
    write_test(n, e);    
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    if (argc > 2 && atoi(argv[2]) == 1)
        n = rnd.next(n / 2, n);
    gen(n);
    return 0;
}