#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 10'000;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(2, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN, "m");
    inf.readEoln();
    
    map<pair<int, int>, bool> isEdge;
   
    for (int i = 0; i < m; i++)
    {
        int a = inf.readInt(1, n, format("a[%d]", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, n, format("b[%d]", i + 1));
        inf.readEoln();
        ensuref(a != b, "a[%d] = b[%d]", i + 1, i + 1);
        ensuref(!isEdge[{a, b}], "Duplicated edge %d %d", a, b);
        isEdge[{a, b}] = isEdge[{b, a}] = true; 
    }
    inf.readEof();
    return 0;
}