#include <iostream>
#include <vector>

using namespace std;

unsigned int dfs(unsigned int v, unsigned int w, vector<vector<unsigned int>> const &g, vector<bool> &vis) {
    vis[v] = true;
    unsigned int res = 0;
    for (unsigned int u : g[v]) {
        if (!vis[u]) {
            res += 1 + dfs(u, v, g, vis);
        } else if (u != w) {
            res += 1;
        }
    }
    return res;
}

int main() {

    unsigned int n, m;
    cin >> n >> m;
    vector<vector<unsigned int>> g(n);

    for (unsigned int i = 0; i < m; i++) {
        unsigned int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }

    vector<bool> vis(n, false);
    for (unsigned int i = 0; i < n; i++) {
        if (!vis[i]) {
            if (dfs(i, n, g, vis) % 2 == 1) {
                cout << "YES\n";
                return 0;
            }
        }
    }

    cout << "NO\n";

}
