#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const ll MAXK = 1'000'000'000'000;
const int MAXA = 10'000'000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);

	vector<pii> segs;
	int l = 0, r = n;
	vector<int> order;
	for (int i = 0; i < n; ++i) {
		segs.push_back({l, r});
		if (rnd.next(0, 1)) {
			order.push_back(l);
			++l;
		} else {
			order.push_back(r);
			--r;
		}
	}

	while (szof(segs) < m) {
		segs.push_back(segs[rnd.next(0, n - 1)]);
	}

	shuffle(segs.begin(), segs.end());

	ll k = rnd.next(0ll, MAXK);

	cout << n << " " << m << " " << k << endl;
	for (int i = 0; i < n; ++i) {
		cout << rnd.next(0, MAXA);
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";
	for (auto p : segs) {
		cout << p.ff + 1 << " " << p.ss << "\n";
	}

	return 0;
}