#include <bits/stdc++.h>

using namespace std;


string s[110];

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
int n;

bool check(int x, int y)
{
	return x >= 0 && x < n && y >= 0 && y < n && s[x][y] == '.';
}

set<pair<int, int> > kek;
set<int> se[110][110];

void close(int x, int y)
{
	for (int i = 0; i < 4; i++)
	{
		if (check(x + dx[i], y + dy[i]))
		{
			int a = x + dx[i];
			int b = y + dy[i];
			kek.erase({se[a][b].size(), a * n + b});
			se[a][b].erase(i ^ 2);
			if (se[a][b].size())
				kek.insert({se[a][b].size(), a * n + b});
		}
	}
	kek.erase({se[x][y].size(), x * n + y});
	se[x][y].clear();
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	s[0] = "";
	for (int i = 0; i < n; i++)
		s[0] += '.';
	for (int i = 1; i < n; i++)
		s[i] = s[0];
	int cnt = 0;
	int cur = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			for (int q = 0; q < 4; q++)
				if (check(i + dx[q], j + dy[q]))
					se[i][j].insert(q);
			if (se[i][j].size())
			    kek.insert({se[i][j].size(), n * i + j});
		}
	}
	while (kek.size())
	{
		auto p = (*kek.begin());
		if (p.first == 1)
		{
			int i = p.second / n;
			int j = p.second % n;
			int q = (*se[i][j].begin());
			int a = i + dx[q];
			int b = j + dy[q];
			s[i][j] = 'a' + cur;
			s[a][b] = 'a' + cur;
			cur++;
			if (cur == 26)
				cur = 0;
			close(i, j);
			close(a, b);
		}
		else
		{
			if (s[cnt][1 + cnt] != '.')
			{
				for (int i = 0; i < n; i++)
					cout << s[i] << "\n";
				assert(false);
			}
			s[cnt][1 + cnt] = '#';
			close(cnt, 1 + cnt);
			cnt++;
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cout << "#";
		}
		cout << "\n";
	}
	return 0;
}