#include "testlib.h"
#include <vector>

using namespace std;

const int MAXN = 100000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, MAXN, "n");
    inf.readSpace();
    int k = inf.readInt(1, n, "k");
    inf.readSpace();
    int t = inf.readInt(2, n, "t");
    inf.readEoln();

    vector<int> a(t);
    for (int i = 0; i < t; ++i) {
        if (i > 0) {
            inf.readSpace();
        }
        a[i] = inf.readInt(1, n, format("a[%d]", i));
    }
    inf.readEoln();

    for (int i = 0; i + 1 < t; ++i) {
        ensuref(a[i] < a[i + 1], "a[%d] >= a[%d], while a must ascend", i, i + 1);
    }
    ensuref(a[0] == 1, "1 must be in a");
    ensuref(a[t - 1] == n, "n must be in a");

    inf.readEof();

    return 0;
}
