#include <iostream>
#include <vector>
#include <iomanip>

using namespace std;

long long fabs(long long x) {
    return x >= 0 ? x : -x;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, k, t;
    cin >> n >> k >> t;
    k--;
    vector<int> v(t);
    for (unsigned int i = 0; i < t; i++) {
        cin >> v[i];
        v[i]--;
    }

    vector<int> low(n), high(n);
    unsigned int idx = 0;
    for (unsigned int i = 0; i < n; i++) {
        if (v[idx] == (int) i) {
            low[i] = (int) i;
            idx++;
        } else {
            low[i] = low[i - 1];
        }
    }
    idx = t - 1;
    for (unsigned int i = n; i > 0; i--) {
        if (v[idx] == (int) i - 1) {
            high[i - 1] = (int) i - 1;
            idx--;
        } else {
            high[i - 1] = high[i];
        }
    }

    long long sum_low = 0, sum_high = 0;
    for (unsigned int i = 0; i < n; i++) {
        sum_low += ((int) i - low[i]) + fabs((int) k - low[i]);
        sum_high += (high[i] - (int) i) + fabs(high[i] - (int) k);
    }

    cout << fixed << setprecision(10) << min((long double) sum_low, (long double) sum_high) / n << '\n';

}
