#include <bits/stdc++.h>

using namespace std;


struct pair_hash {
    long long operator()(pair<long long, long long> const &p) const {
        return hash<long long>()(p.first) * hash<long long>()(p.second);
    }
};

int n, m;
long long a, b;
unordered_map<pair<long long, long long>, int, pair_hash> ans;
queue<pair<int, pair<long long, long long> > > s;

long long f1(long long c, long long d) {
    long double a1 = (long long) sqrt(c * d);
    long double a2 = sqrt(c * d);
    return a1 != a2 ? ((long long) a2 + 1) : (long long) a1;
}


long long f2(long long c, long long d) {
    long double e = c;
    long double f = d;
    long double ans = sqrt(e * e / 2 + f * f / 2);
    return (long long) ans;
}

int main() {
    cin >> a >> b;
    if (a == b) {
        cout << 0;
        return 0;
    }
    ans[{a, b}] = 1;
    s.push({1, {a, b}});
    while (true) {
        auto c = s.front();
        s.pop();
        long long b1 = f1(c.second.first, c.second.second);
        long long a1 = f2(c.second.first, c.second.second);
        if (ans[{a1, b}] == 0) {
            ans[{a1, b}] = c.first + 1;
            s.push({ans[{a1, b}], {a1, b}});
        }
        if (ans[{a, b1}] == 0) {
            ans[{a, b1}] = c.first + 1;
            s.push({ans[{a, b1}], {a, b1}});
        }
        if (ans[{a, a1}] == 0) {
            ans[{a, a1}] = c.first + 1;
            s.push({ans[{a, a1}], {a, a1}});
        }
        if (ans[{b1, b}] == 0) {
            ans[{b1, b}] = c.first + 1;
            s.push({ans[{b1, b}], {b1, b}});
        }
        if (a1 == b || a == b1 || a == a1 || b == b1) {
            cout << c.first;
            break;
        }
    }
    return 0;
}
