#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 250000;
const int M = 998244353;

vector <pair <int, int> > g[N];
int pw[N];

bool bad = false;

bool vis[N];
int ans[N];

void dfs(int v, int col = 0) {
  if (vis[v]) {
    if (ans[v] != col) {
      bad = true;
    }
    return;
  }
  vis[v] = true;
  ans[v] = col;
  for (auto c : g[v]) {
    dfs(c.first, col ^ c.second);
  }
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  pw[0] = 1;
  for (int i = 1; i < n; i++) {
    pw[i] = pw[i - 1] + pw[i - 1];
    if (pw[i] >= M) {
      pw[i] -= M;
    }
  }
  for (int i = 1; i < n; i++) {
    int par;
    cin >> par;
  }
  vector <int> u(m), v(m);
  for (int i = 0; i < m; i++) {
    cin >> u[i] >> v[i];
    u[i]--, v[i]--;
  }
  int ans = 0;
  for (int i = 0; i <= m; i++) {
    for (int i = 0; i < n; i++) {
      g[i].clear();
      vis[i] = false;
    }
    for (int j = 0; j < m; j++) {
      int w = (j >= i);
      g[u[j]].push_back({v[j], w});
      g[v[j]].push_back({u[j], w});
    }
    int st = 0;
    bad = false;
    for (int i = 0; i < n; i++) {
      if (!vis[i]) {
        dfs(i);
        st++;
      }
    }
    if (!bad) {
      ans += pw[st - 1];
      if (ans >= M) {
        ans -= M;
      }
    }
  }
  cout << ans << '\n';
}
