#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 100'000;
const int MAXX = 1'000'000'000;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    int prev_b = -1;
    int prev_t = 0;
    for (int i = 0; i < n; i++)
    {
        int b = inf.readInt(prev_b + 1, MAXX, format("b[%d]", i + 1));
        ensuref(i != 0 || b == 0, "First bound not equal to zero");
        inf.readSpace();
        int t = inf.readInt(prev_t, MAXX, format("t[%d]", i + 1));
        inf.readEoln();
        prev_b = b;
        prev_t = t;
    }
    int m = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    for (int i = 0; i < m; i++)
    {
        inf.readInt(1, MAXX, format("q[%d]", i + 1));
        inf.readEoln();
    }
    inf.readEof();
    return 0;
}