#include "testlib.h"
#include <iostream>

using namespace std;

long long arr[(int)1e5 + 10], mas[(int)1e5 + 10], pref[(int)1e5 + 10];
int n;

void count(long long mi)
{
	fill(arr, arr + n, 0);
	fill(pref, pref + n, 0);
	if (mi == 0)
		return;
	long long cur = mi;
	int cnt = 0;
	while (cur)
	{
		cnt++;
		cur /= n;
	}
	cur = n - 1;
	long long add = 0;
	long long add_without_zero = 0;
	for (int i = 1; i < cnt; i++)
	{
		add += (i - 1) * (cur / n);
		add_without_zero += cur / (n - 1);
		cur *= n;
	}
	cur = 1;
	for (int q = 0; q < cnt - 1; q++)
		cur *= n;
	for (int q = 0; q < cnt; q++)
	{
		long long addd = (cnt - q - 1) * (cur / n);
		pref[(int)(q == 0)] += cur;
		pref[mi / cur] -= cur;
		add += addd * ((mi / cur) - (int)(q == 0)); 
		int i = mi / cur;
		arr[i] += (mi - i * cur + 1);
		mi %= cur;
		cur /= n;
	}
	for (int i = 0; i < n; i++)
	{
		if (i)
			pref[i] += pref[i - 1];
		arr[i] += add + pref[i];
		if (i)
			arr[i] += add_without_zero;
	}
}

int maxx = (int)1e9;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    n = atoll(argv[1]);
    int k = atoi(argv[2]);
    long long le = 0, ri = (long long)1e15 + 10;
    while (ri - le > 1)
    {
    	long long mi = (le + ri) / 2;
    	count(mi);
    	bool d = 0;
    	for (int i = 0; i < n; i++)
    	{
    		if (arr[i] > maxx)
    		{
    			d = 1;
    			break;
    		}
    	}
    	if (d)
    		ri = mi;
    	else
    		le = mi;
    }
    if (k)
    	le = rnd.next(max(1ll, le - 100), le);
    count(le);
    cout << n << "\n";
    for (int i = 0; i < n; i++)
    {
    	if (i)
    		cout << " ";
    	cout << arr[i];
    }
    cout << endl;
    return 0;
}