#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

struct point {
	ll x, y;
	point() {}

	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator*(ll num) const {
		return point(x * num, y * num);
	}

	point ort() const {
		return point(y, -x);
	}
};

ostream& operator<<(ostream& o, point p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

const int MAXC = 1000;
const int MAXN = 12;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int l = atoi(argv[1]);
	vector<pair<point, point>> lines;
	for (int i = 0; i < l; ++i) {
		lines.push_back({point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC)), point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC))});
	}

	map<int, vector<point>> any;

	for (int x = -MAXC; x <= MAXC; ++x) {
		for (int y = -MAXC; y <= MAXC; ++y) {
			point cur(x, y);
			int mask = 0;
			for (int i = 0; i < l; ++i) {
				if (cross(lines[i].ss - lines[i].ff, cur - lines[i].ff) >= 0) {
					mask |= 1 << i;
				}
			}
			any[mask].push_back(cur);
		}
	}

	vector<point> outp;
	for (auto& p : any) {
		outp.push_back(p.ss[rnd.next(0, szof(p.ss) - 1)]);
	}

	shuffle(outp.begin(), outp.end());
	if (szof(outp) > MAXN) {
		outp.resize(MAXN);
	}

	cout << szof(outp) << "\n";
	for (auto p : outp) {
		cout << p.x << " " << p.y << "\n";
	}

	return 0;
}