#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

struct point {
	ll x, y;
	point() {}

	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator*(ll num) const {
		return point(x * num, y * num);
	}

	point ort() const {
		return point(y, -x);
	}

	ll len2() const {
		return x * x + y * y;
	}
};

ostream& operator<<(ostream& o, point p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

const int MAXC = 1000;
const int MAXN = 12;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int dx = atoi(argv[1]);
	int dy = atoi(argv[2]);

	point a(dx > 0 ? -MAXC : MAXC, dy > 0 ? -MAXC : MAXC);
	point b = a + point(dx, dy);

	int best = INF;
	point mem;

	for (int x = -MAXC; x <= MAXC; ++x) {
		for (int y = -MAXC; y <= MAXC; ++y) {
			point cur(x, y);
			int val = cross(b - a, cur - a);
			if (val > 0 && (val < best || (val == best && (cur - a).len2() < (mem - a).len2()))) {
				cerr << val << " " << cur << endl;
				best = val;
				mem = cur;
			}
		}
	}

	cout << "4\n";
	vector<point> points = {a, b, mem, mem + point(dx, dy)};
	shuffle(points.begin(), points.end());
	for (auto p : points) {
		cout << p.x << " " << p.y << "\n";
	}

	return 0;
}