#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MOD = 1000000007;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int q = atoi(argv[2]);

	cout << n << "\n";

	vector<int> dp(26);
	int from = rnd.next(0, 25);
	dp[from] = 1;
	vector<int> next(26);
	vector<int> outp = {from};

	for (int i = 1; i < n; ++i) {
		int diff;
		while (true) {
			diff = rnd.wnext(0, 25, q);
			fill(next.begin(), next.end(), 0);
			for (int j = 0; j < 26; ++j) {
				if (j >= diff) {
					add(next[j], dp[j - diff]);
				}
				if (j + diff < 26) {
					add(next[j], dp[j + diff]);
				}
			}
			if (*max_element(next.begin(), next.end())) {
				break;
			}
		}
		swap(next, dp);
		outp.push_back(diff);
	}

	for (int i = 0; i < n; ++i) {
		cout << outp[i];
		if (i < n - 1) {
			cout << " ";
		}
	}

	cout << "\n";

	return 0;
}