#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif
#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int dist(int i, int limit) {
    int d = i > limit / 2 ? i - limit / 2 : limit / 2 - i;
    return limit - 2 * d;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]), m = atoi(argv[2]);
    long long k = atoll(argv[3]);
    string mode(argv[4]);

    printf("%d %d %lld\n", n, m, k);
    int limit = 10000000;
    for (unsigned int i = 0; i < n; i++) {
        if (i > 0) {
            printf(" ");
        }
        printf("%d", rnd.next(mode != "center" ? 1 : dist(i, limit), limit));
    }
    printf("\n");

    for (unsigned int i = 0; i < m; i++) {
        int l, r;
        if (mode == "center") {
            l = rnd.next(1, n / 2);
            r = rnd.next(n / 2, n);
        } else {
            int len = (mode == "short" ? rnd.next(1, 10) : rnd.next(n / 2, n));
            l = rnd.next(1, n - len + 1);
            r = l + len - 1;
        }
        printf("%d %d\n", l, r);
    }
}