// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

void solve() {
	ll x, y, n, d;
	cin >> n >> x >> y >> d;
	--x; --y;

	auto calc = [&](ll x1, ll y1, ll x2, ll y2) {
		int dx = sign(x2 - x1);
		int dy = sign(y2 - y1);
		// cerr << dx << " " << dy << endl;
		if (abs(x2 - x1) < 100000) {
			int ret = 0;
			while (true) {
				if (0 <= x1 && x1 < n && 0 <= y1 && y1 < n) {
					++ret;
				}
				if (x1 == x2 && y1 == y2) {
					break;
				}
				x1 += dx; y1 += dy;
			}
			return (ll) ret;
		}
		if (x1 < 0) {
			y1 += dy * (-x1);
			x1 = 0;
		}
		if (x1 >= n) {
			y1 += dy * (x1 - (n - 1));
			x1 = n - 1;
		}
		if (x2 < 0) {
			y2 -= dy * (-x2);
			x2 = 0;
		}
		if (x2 >= n) {
			y2 -= dy * (x2 - (n - 1));
			x2 = n - 1;
		}
		ll l = max(0ll, min(y1, y2));
		ll r = min(n - 1, max(y1, y2));
		if (l <= r) {
			return r - l + 1;
		}
		return 0ll;
	};

	ll ans = 0;
	ans += calc(x - d, y, x - 1, y - d + 1);
	ans += calc(x, y - d, x + d - 1, y - 1);
	ans += calc(x + d, y, x + 1, y + d - 1);
	ans += calc(x, y + d, x - d + 1, y + 1);
	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
